Subject: Re: bug#14461: 24.3.50; bad display for 'space' + (U+0336) unicode combination

From: Stephen Berman <[email-masked]>
Date: Sat, 17 Aug 2019 20:58:40 +0200

On Sat, 17 Aug 2019 21:22:09 +0300 Eli Zaretskii <[email-masked]> wrote:

>> From: Stephen Berman <[email-masked]>
>> Cc: [email-masked],  [email-masked],  [email-masked],
>>   [email-masked]
>> Date: Sat, 17 Aug 2019 20:11:19 +0200
>>
>> >> displays just 'a' with an acute accent over it, i.e. the circumflex is
>> >> not displayed at all
>> >
>> > I don't think this is true, I think the accents are overlaid in a way
>> > that makes them hard to distinguish.  Try zooming in, if you can.
>>
>> I find the displays quite unambiguous; here is the output as SVG images:
>
> Then I guess our display is just fine, and the problem is with the
> font after all.

I was about to reply that the difference between the Emacs and the
hb-view display (displaying the circumflex as if it were in the next
column vs. not displaying it at all) is nevertheless striking, but then
it occurred to me to try this:

hb-view /usr/share/fonts/dejavu/DejaVuSansMono.ttf -u 'U+061, U+301, U+302, U+062'

(i.e. the sequence 'a' + COMBINING ACUTE ACCENT + COMBINING CIRCUMFLEX
ACCENT + 'b') and the display shows 'a' with an acute accent over it
followed by 'b' with a circumflex over it.  A slightly different display
is shown by this:

hb-view /usr/share/fonts/dejavu/DejaVuSansMono.ttf -u 'U+061, U+301, U+062, U+302'

(i.e. switching the order of 'b' and the circumflex): here the
circumflex is placed higher than the ascender of 'b', while with the
previous input the circumflex is next to the ascender.  I see exactly
the same display in Emacs with

M-: (insert ?a #x301 #x302 ?b) vs.
M-: (insert ?a #x301 ?b #x302)

I guess in the case of 'U+061, U+301, U+302' hb-view limits the width of
the display to the one alphabetic character.

In short, I agree with your conclusion.

Steve Berman